clang 8.0.0

Public Member Functions | Public Attributes | List of all members
clang::CodeGen::TargetDataInfo Class Reference

Struct that keeps all the relevant information that should be kept throughout a 'target data' region. More...

`#include "/work/www-prereleases/8.0.0/rc2/builddocs/llvm.src/tools/clang/lib/CodeGen/CGOpenMPRuntime.h"`

Collaboration diagram for clang::CodeGen::TargetDataInfo:
[legend]

## Public Member Functions
| TargetDataInfo ()
| TargetDataInfo (bool RequiresDevicePointerInfo)
void | clearArrayInfo ()
| Clear information about the data arrays. More...
bool | isValid ()
| Return true if the current target data information has valid arrays. More...
bool | requiresDevicePointerInfo ()

## Public Attributes
llvm::Value * | BasePointersArray = nullptr
| The array of base pointer passed to the runtime library. More...
llvm::Value * | PointersArray = nullptr
| The array of section pointers passed to the runtime library. More...
llvm::Value * | SizesArray = nullptr
| The array of sizes passed to the runtime library. More...
llvm::Value * | MapTypesArray = nullptr
| The array of map types passed to the runtime library. More...
unsigned | NumberOfPtrs = 0u
| The total number of pointers passed to the runtime library. More...
llvm::DenseMap< const ValueDecl *, Address > | CaptureDeviceAddrMap
| Map between the a declaration of a capture and the corresponding base pointer address where the runtime returns the device pointers. More...

## Detailed Description

Struct that keeps all the relevant information that should be kept throughout a 'target data' region.

Definition at line 1445 of file CGOpenMPRuntime.h.

## Constructor & Destructor Documentation

## ◆ TargetDataInfo() [1/2]

clang::CodeGen::TargetDataInfo::TargetDataInfo | ( |  | ) |
| inline explicit

Definition at line 1464 of file CGOpenMPRuntime.h.

## ◆ TargetDataInfo() [2/2]

clang::CodeGen::TargetDataInfo::TargetDataInfo | ( | bool | RequiresDevicePointerInfo | ) |
| inline explicit

Definition at line 1465 of file CGOpenMPRuntime.h.

## Member Function Documentation

## ◆ clearArrayInfo()

void clang::CodeGen::TargetDataInfo::clearArrayInfo | ( |  | ) |
| inline

Clear information about the data arrays.

Definition at line 1468 of file CGOpenMPRuntime.h.

## ◆ isValid()

bool clang::CodeGen::TargetDataInfo::isValid | ( |  | ) |
| inline

Return true if the current target data information has valid arrays.

Definition at line 1476 of file CGOpenMPRuntime.h.

## ◆ requiresDevicePointerInfo()

bool clang::CodeGen::TargetDataInfo::requiresDevicePointerInfo | ( |  | ) |
| inline

Definition at line 1480 of file CGOpenMPRuntime.h.

References clang::CodeGen::emitDeclareSimdFunction(), clang::CodeGen::emitDoacrossInit(), clang::CodeGen::emitDoacrossOrdered(), clang::CodeGen::emitTargetDataCalls(), and clang::CodeGen::emitTargetDataStandAloneCall().

## Member Data Documentation

## ◆ BasePointersArray

llvm::Value* clang::CodeGen::TargetDataInfo::BasePointersArray = nullptr

The array of base pointer passed to the runtime library.

Definition at line 1451 of file CGOpenMPRuntime.h.

Referenced by clang::CodeGen::emitTargetNumIterationsCall(), and clang::CodeGen::markAsGlobalTarget().

## ◆ CaptureDeviceAddrMap

llvm::DenseMap<const ValueDecl *, Address> clang::CodeGen::TargetDataInfo::CaptureDeviceAddrMap

Map between the a declaration of a capture and the corresponding base pointer address where the runtime returns the device pointers.

Definition at line 1462 of file CGOpenMPRuntime.h.

## ◆ MapTypesArray

llvm::Value* clang::CodeGen::TargetDataInfo::MapTypesArray = nullptr

The array of map types passed to the runtime library.

Definition at line 1457 of file CGOpenMPRuntime.h.

Referenced by clang::CodeGen::emitTargetNumIterationsCall(), and clang::CodeGen::markAsGlobalTarget().

## ◆ NumberOfPtrs

unsigned clang::CodeGen::TargetDataInfo::NumberOfPtrs = 0u

The total number of pointers passed to the runtime library.

Definition at line 1459 of file CGOpenMPRuntime.h.

Referenced by clang::CodeGen::emitTargetNumIterationsCall(), and clang::CodeGen::markAsGlobalTarget().

## ◆ PointersArray

llvm::Value* clang::CodeGen::TargetDataInfo::PointersArray = nullptr

The array of section pointers passed to the runtime library.

Definition at line 1453 of file CGOpenMPRuntime.h.

Referenced by clang::CodeGen::emitTargetNumIterationsCall(), and clang::CodeGen::markAsGlobalTarget().

## ◆ SizesArray

llvm::Value* clang::CodeGen::TargetDataInfo::SizesArray = nullptr

The array of sizes passed to the runtime library.

Definition at line 1455 of file CGOpenMPRuntime.h.

Referenced by clang::CodeGen::emitTargetNumIterationsCall(), and clang::CodeGen::markAsGlobalTarget().

The documentation for this class was generated from the following file:

- lib/CodeGen/CGOpenMPRuntime.h